if RUBY_PLATFORM == 'opal'

require 'native'
require 'opal-webix'
require 'volt-watch'

module Webix
  class MainController < Volt::ModelController
    include Volt::Watch

    attr_reader :reactive

    def index_ready
      debug __method__, __LINE__
      init_layout
      init_webix
    end

    def before_index_remove
      debug __method__, __LINE__
      stop_watches
      deinit_webix
    end

    def webix
      page._webix
    end

    protected

    def init_layout
      @layout = attrs.layout
      unless @layout
        raise ArgumentError, 'layout attribute must be given for :webix component'
      end
    end

    def init_webix
      page._webix = $webix
      page._webix.ui << @layout.to_h
    end

    def deinit_webix
      page._webix = nil
    end

    def debug(_method, line, s = nil)
      Volt.logger.debug "#{self.class.name}##{_method}[#{line}] : #{s}"
    end

  end
end

end # RUBY_PLATFORM == 'opal'
